using System;
using System.Drawing;
using System.Windows.Forms;

namespace Undo_Example {
	public class AddButtonCommand : Command {
		Form form;
		Button button = null;
		string text;

		public AddButtonCommand(Form form, string text) {
			this.form = form;
			this.text = text;
		}

		public override void Execute() {
			button = new Button();
			button.FlatStyle = FlatStyle.System;
			button.Text = text;

			Point loc = Point.Empty;
			if (form.Controls.Count > 0) {
				Control lastControl = form.Controls[form.Controls.Count-1];
				loc = new Point(0, lastControl.Bottom);
			}
			button.Location = loc;
			form.Controls.Add(button);
		}

		public override void Undo() {
			if (button != null) {
				form.Controls.Remove(button);
				button = null;
			}
		}
	}
}