using System;
using System.Drawing;
using System.Windows.Forms;

namespace Undo_Example {
	public class AddCheckBoxCommand : Command {
		Form form;
		CheckBox checkbox = null;
		string text;

		public AddCheckBoxCommand(Form form, string text) {
			this.form = form;
			this.text = text;
		}

		public override void Execute() {
			checkbox = new CheckBox();
			checkbox.FlatStyle = FlatStyle.System;
			checkbox.Text = text;

			Point loc = Point.Empty;
			if (form.Controls.Count > 0) {
				Control lastControl = form.Controls[form.Controls.Count-1];
				loc = new Point(0, lastControl.Bottom);
			}
			checkbox.Location = loc;
			form.Controls.Add(checkbox);
		}

		public override void Undo() {
			if (checkbox != null) {
				form.Controls.Remove(checkbox);
				checkbox = null;
			}
		}
	}
}